#include "spell.hpp"
#ifndef DISABLE_SPELL

namespace Spell {
	Hunspell* hun = new Hunspell(HUNSPELL_AFF_EN, HUNSPELL_DIC_EN);
	uint8_t hid_buf[RAW_EPSIZE]; // Write buffer
	

	// Replacement chars for now, since wide strings are hard.
	char ru_kc_to_char(uint8_t keycode) {
		switch (keycode) {
			case KC_GRAVE:
				return '~';//L"ё";
			case KC_1:
				return '1';//L"1";
			case KC_2:
				return '2';//L"2";
			case KC_3:
				return '3';//L"3";
			case KC_4:
				return '4';//L"4";
			case KC_5:
				return '5';//L"5";
			case KC_6:
				return '6';//L"6";
			case KC_7:
				return '7';//L"7";
			case KC_8:
				return '8';//L"8";
			case KC_9:
				return '9';//L"9";
			case KC_0:
				return '0';//L"0";
			case KC_Q:
				return '^';//L"й";
			case KC_W:
				return '*';//L"ц";
			case KC_E:
				return 'y';//L"у";
			case KC_R:
				return 'k';//L"к";
			case KC_T:
				return 'e';//L"е";
			case KC_Y:
				return 'H';//L"н";
			case KC_U:
				return 'g';//L"г";
			case KC_I:
				return 'w';//L"ш";
			case KC_O:
				return 'W';//L"щ";
			case KC_P:
				return 'z';//L"з";
			case KC_LEFT_BRACKET:
				return 'x';//L"х";
			case KC_RIGHT_BRACKET:
				return '!';//L"ъ";
			case KC_A:
				return 'f';//L"ф";
			case KC_S:
				return 'i';//L"ы";
			case KC_D:
				return 'B';//L"в";
			case KC_F:
				return 'a';//L"а";
			case KC_G:
				return 'n';//L"п";
			case KC_H:
				return 'p';//L"р";
			case KC_J:
				return 'o';//L"о";
			case KC_K:
				return 'l';//L"л";
			case KC_L:
				return 'd';//L"д";
			case KC_SEMICOLON:
				return 'j';//L"ж";
			case KC_QUOTE:
				return 'E';//L"э";
			case KC_Z:
				return 'R';//L"я";
			case KC_X:
				return 'q';//L"ч";
			case KC_C:
				return 'c';//L"с";
			case KC_V:
				return 'm';//L"м";
			case KC_B:
				return 'n';//L"и";
			case KC_N:
				return 't';//L"т";
			case KC_M:
				return '=';//L"ь";
			case KC_COMMA:
				return 'b';//L"б";
			case KC_DOT:
				return 'u';//L"ю";
			default:
				spdlog::warn("Unknown keycode passed to ru_kc_to_char");
				return '?';//L"?";
		}
	}


	void do_cmd(Ergodox &Dox) {
		char word_chars[Dox.read_buf[1] + 1];

		if (Dox.get_layer_layout() == LAYOUT_EN) {
			for (int i=0; i < Dox.read_buf[1]; i++) {
				// A in ascii:
				// a in ascii: 0x61
				// KC_A: 0x04
				word_chars[i] = Dox.read_buf[i + 2] + 0x5D;
			}
		} else if (Dox.get_layer_layout() == LAYOUT_RU) {
			for (int i=0; i < Dox.read_buf[1]; i++) {
				word_chars[i] = ru_kc_to_char(Dox.read_buf[i + 2]);
			}
		}
		word_chars[Dox.read_buf[1]] = 0x00; // Terminate with null char
		std::string word = std::string(word_chars);

		int dp = hun->spell(word);
		if (!dp) {
			memset(hid_buf, 0, sizeof(uint8_t) * Dox.packet_size);
			hid_buf[0] = 0x01;
			Dox.write(CMD_SPELLCHECK_WORD, hid_buf, Dox.packet_size);
			//spdlog::info("Got typo: \"{0:s}\" not in dict", word);
		}
	}
}

#endif